<!DOCTYPE html>
<html lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/>
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=1024">
    <link rel="Shortcut Icon" href="#{assets '/images/4.3.png'/}" type="image/x-icon" />
    <link href="#{assets '/css/bootstrap-datetimepicker.min.css'/}" rel="stylesheet"/>
    <link href="#{assets '/handsontable/handsontable.full.min.css'/}" rel="stylesheet" type="text/css">
    <style>
        .wtHolder{
            height:auto !important;
        }

        .htCore{
            height:auto !important;
        }

    </style>
    <title>&{'kontrak.rincian_barang'}</title>
</head>
<body>
<div class="content">
    #{if isSpse3}
        <table id="template" class="table table-sm">
            <tr>
                <th ><a class="btn btn-default btn-sm" href="#" onClick="$('#rincian_upload').click()" id="uploadHPS">&{'kontrak.upload_rincian'}</a>
                    <a href="#{assets '/documents/template-rincian.csv'/}" class="btn btn-default btn-sm"><i class="glyphicon glyphicon-download"></i> Template Rincian</a></th>
                <th><input type="file" id="rincian_upload" class="form-control" style="display:none" placeholder="Upload Rincian"></th>
            </tr>
        </table>
    #{/if}
    <div class="bs-callout bs-callout-info">
        &{'kontrak.menambah_baris'}
    </div>
    <div id="tbl-rincian" style="margin-bottom:20px;"></div>
    <div style="margin-left: 65%;">
        <table id="rekap" class="table table-responsive" style="width:300px;margin-right:50px;">
            <tr>
                <th style="text-align:right">&{'kontrak.total_nilai'}</th>
                <th class="total" style="text-align:right"></th>
            </tr>
            
 <!--           <tr>
                <th style="text-align:right">PPN 10%</th>
                <th class="ppn" style="text-align:right"></th>
            </tr>
            <tr>
                <th style="text-align:right">TOTAL NILAI</th>
                <th class="total_hps" style="text-align:right"></th>
            </tr> -->
        </table>
    </div>
</div>
#{if isSpse3}
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/vendor/jquery.ui.widget.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.iframe-transport.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-process.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-validate.min.js"></script>
#{/if}

<script type="text/javascript" src="#{assets '/handsontable/handsontable.full.min.js'/}"></script>
<script type="text/javascript" src="#{assets '/js/common.js'/}"></script>

<script type="text/javascript">
    var data =${data?.raw()};
    var interval = 2 * 60 * 1000; // 2 menit
    var total = 0;
    var fixed = true;
    console.log(data.length)
    if(data.length == 0) {
        data.push({item:null, unit:'-', vol:0, unit2:'-', vol2:0, harga:0,pajak:0, total_harga:0,keterangan:'-'});
    }

    $("#tbl-rincian").handsontable({
        autoWrapRow: true,
        colHeaders:["Jenis Barang/Jasa", "Unit ", "Vol", "Unit2","Vol2","Harga","Pajak(%)", "Total", "Keterangan"],
        rowHeaders: true,
        renderAllRows: true,
        data: data,
        manualColumnResize: true,
        renderAllRows:true,
        #{if !isSpse3}
        maxRows: data.numberOfRows,
        maxCols: data.numberOfColumns,
        #{/if}
        dataSchema : {item:null, unit:'-', vol:0, unit2:'-', vol2:0, harga:0,pajak:0, total_harga:0,keterangan:'-'},
        colWidths: [200, 70, 50, 70, 50, 100,59,100,98],
        #{if isSpse3}
            contextMenu: ["row_above", "row_below"],
        #{/if}
        #{else}
            contextMenu: ["row_above", "row_below","remove_row",  "undo", "redo"],
        #{/else}
	    columns: [{data:"item"},  {data:"unit"},
		    {data:"vol", type:'numeric'}, {data:"satuan2"},
		    {data:"vol2", type:'numeric'}, {data:"harga", type:'numeric', format:'Rp 0,0.00'},
		    {data:"pajak", type:'numeric'}, {data:"total_harga",type:'numeric', format:'Rp 0,0.00', readOnly: true},
		    {data:"keterangan"}],
        cells: function (row, col, prop) {
            var cellProperties = {};

            if(col == 7 && data[row]) {
                cellProperties.readOnly = true;
                if(data[row].vol == null){
                    data[row].vol = 0;
                }

                if(data[row].vol2 == null){
                    data[row].vol2 = 0;
                }

                if(data[row].harga == null){
                    data[row].harga = 0;
                }

                if(data[row].total_harga == null){
                    data[row].total_harga = 0;
                }

                if(data[row].pajak == null){
                    data[row].pajak = 0;
                }
                data[row].total_harga = (data[row].vol * data[row].vol2) *
                        (data[row].harga + ((data[row].harga * data[row].pajak)/100));
            }

            return cellProperties;
        },
        afterChange: function (change, source) {
            countTotal();
        },
        afterRemoveRow: function(){
            countTotal();
        }
    });

   function countTotal(){
       var total = 0;
       var ppn = 0;
       var total_hps = 0;
       for(i=0; i < data.length;i++) {
           if(data[i].total_harga)
               ppn += ((data[i].harga * data[i].pajak)/100) * (data[i].vol * data[i].vol2) ;
               total += data[i].total_harga ;
       }
       if(total > 0) {
           total_hps = total + ppn;
           $("#rekap").find(".total").text(toRupiah(rounded2Decimal(total)));
           $("#rekap").find(".ppn").text(toRupiah(rounded2Decimal(ppn)));
           $("#rekap").find(".total_hps").text(toRupiah(rounded2Decimal(total_hps)));
       } else {
           $("#rekap").find(".total").text(0);
           $("#rekap").find(".ppn").text(0);
           $("#rekap").find(".total_hps").text(0);
       }
       autosave();
   }

    $("#fixed").on('change', function () {
        fixed = this.checked ? false:true;
    });
    function autosave() {
        var postdata = $("#tbl-rincian").data('handsontable');
        var token = $("input[name='authenticityToken']").val();
        $.ajax({
            url: '@{kontrak.SppCtr.simpanRincian(lelang.lls_id,pesananx,pesananx.pes_tgl)}',
            data: {"data": postdata.getData()},
            dataType: 'json',
            type: 'POST',
            success: function (res) {
                if (res.result == 'ok'){
                   console.log("Data berhasil disimpan");
                }
                else if(res.result.length > 0)
                    BootstrapDialog.alert({message:res.result, type:BootstrapDialog.TYPE_DANGER})
                else
                    BootstrapDialog.alert({message:'Data gagal tersimpan, mohon periksa kembali isian Anda', type:BootstrapDialog.TYPE_DANGER})
            },
            error: function () {

            }
        });
    }
    setInterval(autosave, interval);

    // ---------------------- CSV ke Table Rincian Barang-------------------------
    $(document).on('change','#rincian_upload', function(evt) {

        var file = evt.target.files[0];
        var reader = new FileReader();
        reader.onload = function(progressEvent){
            var lines = this.result.split('\n');
            var rows = lines.length;
            var foundSeparator = false;
            var validAll = true;
            var firstSeparator ="d";
            for(var line = 0; line < rows ; line++){
                if(lines[line].length > 0){
                    //console.log("========================================================> record :"+line)
                    //console.log(lines[line]+" : line => "+line);
                    var coma = (lines[line].indexOf(",") > 0);//found
                    var seco = (lines[line].indexOf(";") > 0);//found
                    //console.log(coma + " : "+ seco);
                    if(coma && seco ){
                        validAll=false;
                        break;//exit for
                        // console.log('bad 2 found');
                    }else if(coma || seco ){
                        if(firstSeparator=="d"){
                            //firs found separator is?
                            if(coma){
                                firstSeparator=",";
                                //		  console.log("koma");
                            }
                            if(seco){
                                firstSeparator=";";
                                //		  console.log("koma");
                            }
                        }else{
                            //console.log(firstSeparator);
                            //not valid if previous separator is diferent
                            if(coma && (firstSeparator != ",")){
                                validAll=false;//
                                break;//exit for
                            }
                            if(seco && (firstSeparator!= ";")){
                                validAll=false;
                                break;//exit for
                            }
                            //console.log(coma + " " + (firstSeparator==","))
                            //console.log(seco + " " + (firstSeparator==";"));
                        }
                    }
                    //console.log("========================================================> END record :"+line)
                }
            }//end for
            //console.log(validAll+" valid all")
            if(validAll){
                parseCsvLoadHandsontable(file);
            }else{
                alert("File HPS Anda memiliki format yang tidak valid.");
            }
            $('input[type=file]').val("");
        };
        reader.readAsText(file);

    });

    function parseCsvLoadHandsontable(file){
        Papa.parse(file, {
            //header: true,
            //asep
            delimiter: "",	// auto-detect
            newline: "",	// auto-detect
            dynamicTyping: true,
            complete: function(results) {
                var res = results.data;
                var obj = new Array();
                for(i=1;i<res.length;i++){

                    var totalharga = 0;
                    var pajak = 0;

                    if(!parseInt(res[i][2], 10)){
                        res[i][2]=0;
                    } else{
                        totalharga = res[i][2] * res[i][5];
                    }

                    if(!parseInt(res[i][4], 10)){
                        //console.log("vol2 not null");
                        res[i][4]=1;
                    }
                    if(res[i][4] > 0){
                        console.log("if 2 :"+parseInt(res[i][2], 10))
                        totalharga = res[i][2] * res[i][4] * res[i][5];
                    }

                    //pajak ga boleh null
                    if(!parseInt(res[i][6], 10)){
                        res[i][6]=0;
                    }
                    if(res[i][6] > 0){
                        pajak = (res[i][6] / 100) * totalharga;
                        totalharga +=pajak;
                    }
                    obj.push({
                        item: replaceChar(res[i][0]),
                        unit: replaceChar(res[i][1]),
                        vol:res[i][2],
                        unit2: replaceChar(res[i][3]),
                        vol2:res[i][4],
                        harga:res[i][5],
                        pajak:res[i][6],
                        //asep:total to auto
                        //total_harga:res[i][7],
                        total_harga:totalharga,
                        keterangan: replaceChar(res[i][7]) })

                }
                data = obj;
                $("#tbl-rincian").handsontable("loadData", obj);
                countTotal();
            }
        });
    }

    function replaceChar(str){
        var strs ="";
        strs +=str;
        return strs.replace(/[^a-zA-Z0-9.,!@#$%&@*()-+=/\-\s ]/g,"");
    }
    // ----------------------------------end CSV ke Table Rincian Barang----------------------------------
</script>
</body>
</html>